import { defineComponent as A, inject as ie, computed as te, openBlock as C, createElementBlock as I, normalizeClass as M, renderSlot as j, ref as O, createElementVNode as N, unref as V, toDisplayString as U, Fragment as q, renderList as Q, withModifiers as W, createTextVNode as Z, normalizeStyle as ae, createCommentVNode as Y, withKeys as J, withDirectives as ue, isRef as ee, vModelText as se, nextTick as _, provide as ce, createBlock as pe, withCtx as ne, createVNode as fe, getCurrentInstance as ge } from "vue";
const re = Symbol("SELECTED_PROVIDE");
let he = { checkboxId: 0 };
const me = ["disabled"], ve = /* @__PURE__ */ A({
  __name: "CButton",
  props: {
    type: { default: "default" },
    disabled: { type: Boolean, default: !1 },
    selectable: { type: Boolean, default: !1 },
    modelValue: { type: Boolean, default: !1 },
    data: { default: void 0 }
  },
  emits: {
    click: (s) => !0,
    "update:model-value": (s) => !0,
    change: (s) => !0
  },
  setup(s, { emit: l }) {
    const a = s, t = l;
    let e = ie(re, null);
    const c = te(() => {
      if (e) {
        if (e.selectMode == "single")
          return e.value == a.data;
        if (e.selectMode == "multiple")
          return e.value.indexOf(a.data) != -1;
      } else
        return a.selectable ? a.modelValue : !1;
    });
    function g(w) {
      if (e && e.change(a.data, !c.value), !a.disabled && a.selectable) {
        const S = !c.value;
        t("update:model-value", S), t("change", S);
      }
      t("click", w);
    }
    return (w, S) => (C(), I("button", {
      class: M([
        "c-button-" + w.type + (w.disabled ? "-disabled" : ""),
        c.value ? "c-button-" + w.type + "-selected" : ""
      ]),
      disabled: w.disabled,
      onClick: g
    }, [
      j(w.$slots, "default")
    ], 10, me));
  }
}), De = ["id", "value", "disabled"], be = ["for"], Se = /* @__PURE__ */ A({
  __name: "CCheckBox",
  props: {
    disabled: { type: Boolean, default: !1 },
    modelValue: { default: "false" },
    label: { default: "" }
  },
  emits: {
    "update:model-value": (s) => !0,
    change: (s) => !0
  },
  setup(s, { emit: l }) {
    let a = O("c-check-box-" + (++he.checkboxId).toString());
    const t = l;
    function e(c) {
      const g = c.target.value;
      t("update:model-value", g), t("change", g);
    }
    return (c, g) => (C(), I("div", null, [
      N("input", {
        id: V(a),
        type: "checkbox",
        value: c.modelValue,
        disabled: c.disabled,
        class: M([
          "c-check-box" + (c.disabled ? "-disabled" : "")
        ]),
        onInput: e
      }, null, 42, De),
      N("label", { for: V(a) }, U(c.label), 9, be)
    ]));
  }
}), we = /* @__PURE__ */ A({
  __name: "CGroup",
  props: {
    orientation: { default: "landscape" }
  },
  setup(s) {
    return (l, a) => (C(), I("div", {
      class: M(["c-group-" + l.orientation])
    }, [
      j(l.$slots, "default")
    ], 2));
  }
});
class oe {
  winId = $.instance.winId;
  widgetId;
  widgetType;
  list = [];
}
class H {
  /**
   * 拖入的数据点
   */
  index;
  /**
   * 数据的parent对象，一般是Array
   */
  parent;
  /**
   * 窗口id
   */
  winId = $.instance.winId;
  /**
   * 组件id
   */
  widgetId;
  /**
   * 组件的类型
   */
  widgetType;
}
class $ {
  static instance = new $();
  _winId = (/* @__PURE__ */ new Date()).getTime();
  /**
   * 当前窗口ID，表示数据来源的窗口。
   */
  get winId() {
    return this._winId;
  }
  _widgetId = 0;
  /**
   * 生成新的控件ID，用于标识数据来月的控件。
   */
  get widgetId() {
    return ++this._widgetId;
  }
  /**
   * 验证是否为DragData
   * @param data 
   */
  getDragData(l) {
    if (l[0] != "{")
      return null;
    try {
      let a = JSON.parse(l);
      if (a.winId != null && a.widgetId != null)
        return a;
    } catch {
      return null;
    }
    return null;
  }
  /**
   * 如果是当前窗口发起的拖拽，则保存当前的拖拽信息
   */
  currentDragData;
}
const ye = ["onClick", "draggable", "onDragstart", "onDragover", "onDragleave", "onDrop", "onDragend"], Ce = {
  key: 0,
  class: "c-list-input"
}, Ve = /* @__PURE__ */ A({
  __name: "CList",
  props: {
    dataSource: {},
    modelValue: {},
    bindKey: { default: "" },
    multiChoice: { type: Boolean, default: !1 },
    hideBorder: { type: Boolean, default: !1 },
    itemDraggable: { type: Boolean, default: !1 }
  },
  emits: {
    "update:model-value": (s) => !0,
    change: (s) => !0,
    submit: (s) => !0,
    itemdragstart: (s, l) => !0,
    itemdropallow: (s, l, a) => !0,
    itemdrop: (s, l, a) => !0
  },
  setup(s, { emit: l }) {
    const a = O(null), t = s;
    let e = O(!1), c = O(0), g = O(null), w = $.instance.widgetId;
    const S = l;
    function k(d, f, m) {
      if (t.multiChoice) {
        let r = null;
        if (d.shiftKey)
          if (g.value == null)
            r = [f], g.value = f;
          else {
            r = [];
            let i = !1, v = g.value, E = f;
            t.dataSource.indexOf(g.value) > t.dataSource.indexOf(f) && (v = f, E = g.value);
            for (let F = 0; F < t.dataSource.length; F++) {
              let n = t.dataSource[F];
              n == v ? i = !0 : n == E && (i = !1), (i || n == E) && r.push(n);
            }
          }
        else if (d.ctrlKey) {
          const i = t.modelValue;
          r = i.concat(), i.indexOf(f) == -1 ? (r.push(f), g.value = f) : (r.splice(r.indexOf(f), 1), g.value = null);
        } else
          r = [f], g.value = f;
        r != null && (S("update:model-value", r), S("change", r));
      } else
        S("update:model-value", f), S("change", f), p();
    }
    function B(d, f, m) {
      let r = new oe();
      r.widgetType = "c-list", r.widgetId = w;
      let i;
      if (t.multiChoice) {
        const v = t.modelValue;
        v == null || v.indexOf(f) == -1 ? (i = [f], S("update:model-value", i), S("change", i)) : i = v;
      } else
        t.modelValue != f ? (i = f, S("update:model-value", i), S("change", i)) : i = t.modelValue;
      if (t.multiChoice)
        for (let v of i)
          r.list.push({
            data: v,
            index: t.dataSource.indexOf(v),
            parent: t.dataSource
          });
      else
        r.list.push({
          data: i,
          index: m,
          parent: t.dataSource
        });
      S("itemdragstart", d, r), !d.defaultPrevented && d.dataTransfer && (d.dataTransfer.dropEffect = "move", d.dataTransfer.setData(
        "application/json",
        JSON.stringify(r)
      ), d.dataTransfer.setDragImage(d.target, 0, 0), $.instance.currentDragData = r);
    }
    function P(d, f, m) {
      let r = G(d, m), i = new H();
      i.widgetType = "c-list", i.widgetId = w, i.index = r.index, i.parent = t.dataSource, S(
        "itemdropallow",
        d,
        i,
        $.instance.currentDragData
      ), d.defaultPrevented && (c.value = r.top, e.value = !0);
    }
    function L(d, f, m) {
      e.value = !1;
    }
    function x(d, f, m) {
      e.value = !1;
      let r = G(d, m), i = new H();
      i.widgetType = "c-list", i.widgetId = w, i.index = r.index, i.parent = t.dataSource, S(
        "itemdrop",
        d,
        i,
        $.instance.currentDragData
      );
    }
    function z(d, f, m) {
      $.instance.currentDragData = void 0;
    }
    function G(d, f) {
      let m = d.currentTarget, r = m.getBoundingClientRect(), i = m.parentElement.getBoundingClientRect(), v = r.top - i.top + m.parentElement.scrollTop;
      return d.clientY > r.top + r.height / 2 ? { index: f + 1, top: v + r.height } : { index: f, top: v };
    }
    var o = "";
    function D(d) {
      if (!(d.ctrlKey || d.altKey || d.metaKey || d.shiftKey))
        if (d.code == "ArrowUp" || d.code == "ArrowDown") {
          if (t.modelValue == null) {
            const f = t.multiChoice ? [t.dataSource[0]] : t.dataSource[0];
            S("update:model-value", f), S("change", f), a.value.scrollTop = 0;
          } else {
            let f = null;
            t.multiChoice ? f = t.modelValue[0] : f = t.modelValue;
            let m = t.dataSource.indexOf(f), r = d.code == "ArrowUp" ? m - 1 : m + 1, i = t.dataSource[r];
            if (i) {
              const v = t.multiChoice ? [i] : i;
              S("update:model-value", v), S("change", v), a.value.children[r].scrollIntoView({
                block: "nearest"
                // behavior: "smooth"//不要动画效果更好
              });
            }
          }
          d.preventDefault();
        } else if (d.code >= "KeyA" && d.code <= "KeyZ" || d.code >= "Digit0" && d.code <= "Digit9" || d.code >= "Numpad0" && d.code <= "Numpad9") {
          let f = d.code.replace(/Key|Digit|Numpad/g, "");
          o += f, T();
        } else
          d.code == "Enter" ? o != "" ? T() : p() : d.code == "Backspace" && o != "" ? (o = o.substr(0, o.length - 1), o != "" && T()) : d.code == "Escape" && (o = "");
    }
    function p() {
      S("submit", t.modelValue);
    }
    function T() {
      let d = [], f = 0;
      t.multiChoice ? f = t.modelValue == null ? 0 : t.dataSource.indexOf(t.modelValue[0]) + 1 : f = t.modelValue == null ? 0 : t.dataSource.indexOf(t.modelValue) + 1, f >= a.value.children.length && (f = 0);
      for (let m = f; m < a.value.children.length; m++)
        d.push(a.value.children[m]);
      for (let m = 0; m < f; m++)
        d.push(a.value.children[m]);
      for (let m of d)
        if ((m.textContent || "").replace(/(?![A-Z|a-z|0-9])/g, "").toUpperCase().indexOf(o) != -1) {
          let i = t.dataSource[Array.prototype.indexOf.call(a.value.children, m)];
          const v = t.multiChoice ? [i] : i;
          S("update:model-value", v), S("change", v), m.scrollIntoView({ block: "nearest" });
          break;
        }
    }
    return (d, f) => (C(), I("div", {
      class: M(["c-list-out-box", { "c-list-no-border": d.hideBorder }]),
      tabindex: "0",
      onKeydown: D
    }, [
      N("div", {
        class: M(["c-list-in-box", { "c-list-no-border": d.hideBorder }]),
        ref_key: "list",
        ref: a
      }, [
        (C(!0), I(q, null, Q(d.dataSource, (m, r) => (C(), I("div", {
          key: d.bindKey == "" ? "k" + r : m[d.bindKey],
          class: M(["c-list-item", { "c-list-item-sel": d.multiChoice ? d.modelValue.indexOf(m) != -1 : d.modelValue == m }]),
          onClick: W((i) => k(i, m), ["left"]),
          draggable: d.itemDraggable,
          onDragstart: (i) => B(i, m, r),
          onDragover: (i) => P(i, m, r),
          onDragleave: (i) => L(),
          onDrop: (i) => x(i, m, r),
          onDragend: (i) => z()
        }, [
          j(d.$slots, "item", {
            item: m,
            index: r
          }, () => [
            Z(U(r + ":" + JSON.stringify(m)), 1)
          ])
        ], 42, ye))), 128)),
        V(e) ? (C(), I("div", {
          key: 0,
          class: "c-list-drop-view",
          style: ae({ top: V(c) + "px" })
        }, null, 4)) : Y("", !0)
      ], 2),
      V(o) != "" ? (C(), I("label", Ce, U(V(o)), 1)) : Y("", !0)
    ], 34));
  }
}), Ie = ["tabindex", "disabled"], xe = { class: "c-number-input-label" }, ke = { class: "c-number-input-value" }, Te = /* @__PURE__ */ A({
  __name: "CNumberInput",
  props: {
    label: { default: "" },
    modelValue: { default: 0 },
    disabled: { type: Boolean, default: !1 },
    minValue: {},
    maxValue: {},
    step: { default: 1 }
  },
  emits: {
    "update:model-value": (s) => !0,
    change: (s) => !0
  },
  setup(s, { emit: l }) {
    var a = "1234567890.-";
    let t = s, e = O(t.modelValue), c = O(!1), g = O("");
    const w = O(null), S = O(null), k = l;
    function B(r) {
      return t.minValue != null && (r = Math.max(t.minValue, r)), t.maxValue != null && (r = Math.min(t.maxValue, r)), r;
    }
    function P(r, i) {
      let v = (F) => {
        r(F);
      }, E = (F) => {
        i(F), document.removeEventListener("mousemove", v), document.removeEventListener("mouseup", E);
      };
      document.addEventListener("mousemove", v), document.addEventListener("mouseup", E);
    }
    function L(r) {
      r();
      let i, v = setTimeout(() => {
        i = setInterval(() => {
          r();
        }, 10);
      }, 500), E = (F) => {
        clearInterval(i), clearTimeout(v), document.removeEventListener("mouseup", E);
      };
      document.addEventListener("mouseup", E);
    }
    function x(r) {
      if (t.disabled)
        return;
      let i = r.clientX, v = e.value;
      P(
        (E) => {
          let n = (E.clientX - i) * 2 * t.step / 10, u = B(v + n);
          e.value = Math.floor(u / t.step) * t.step, k("update:model-value", e.value), k("change", e.value);
        },
        (E) => {
        }
      );
    }
    function z(r) {
      r.stopPropagation(), r.stopImmediatePropagation(), !t.disabled && L(() => {
        e.value = B(e.value - t.step), k("update:model-value", e.value), k("change", e.value);
      });
    }
    function G(r) {
      r.stopPropagation(), r.stopImmediatePropagation(), !t.disabled && L(() => {
        e.value = B(e.value + t.step), k("update:model-value", e.value), k("change", e.value);
      });
    }
    const o = te(() => t.maxValue != null && t.minValue != null ? (e.value - t.minValue) / (t.maxValue - t.minValue) : 0);
    function D() {
      e.value = B(e.value - t.step), k("update:model-value", e.value), k("change", e.value);
    }
    function p() {
      e.value = B(e.value + t.step), k("update:model-value", e.value), k("change", e.value);
    }
    async function T() {
      c.value = !0, g.value = e.value.toString(), await _(), S.value.focus();
    }
    async function d() {
      c.value != !1 && (c.value = !1, g.value = "", await _(), w.value.focus());
    }
    async function f() {
      c.value = !1;
      let r = parseFloat(g.value);
      (r == null || isNaN(r)) && (r = 0), r = B(r), e.value = Math.floor(r / t.step) * t.step, k("update:model-value", e.value), k("change", e.value), g.value = "", await _(), w.value.focus();
    }
    async function m(r) {
      a.indexOf(r.key) != -1 && (c.value = !0, await _(), S.value.focus());
    }
    return (r, i) => V(c) ? ue((C(), I("input", {
      key: 1,
      ref_key: "editor",
      ref: S,
      type: "text",
      autocomplete: "off",
      "onUpdate:modelValue": i[0] || (i[0] = (v) => ee(g) ? g.value = v : g = v),
      class: "c-number-input",
      onKeydown: [
        J(d, ["esc"]),
        J(f, ["enter"])
      ],
      onBlur: d
    }, null, 544)), [
      [se, V(g)]
    ]) : (C(), I("div", {
      key: 0,
      ref_key: "view",
      ref: w,
      class: M([V(t).disabled ? "c-number-input-disabled" : "c-number-input"]),
      style: ae({ "--progress": o.value * 100 + "%" }),
      onMousedown: x,
      tabindex: V(t).disabled ? "" : 0,
      onKeydown: [
        J(D, ["left"]),
        J(p, ["right"]),
        J(T, ["enter"]),
        m
      ],
      disabled: V(t).disabled
    }, [
      N("label", {
        class: "c-number-input-left",
        onMousedown: z
      }, "◀", 32),
      N("label", xe, U(V(t).label) + ":", 1),
      N("label", ke, U(V(e)), 1),
      N("label", {
        class: "c-number-input-right",
        onMousedown: G
      }, "▶", 32)
    ], 46, Ie));
  }
}), Oe = /* @__PURE__ */ A({
  __name: "CSelectableGroup",
  props: {
    orientation: { default: "landscape" },
    selectMode: { default: "single" },
    modelValue: { default: void 0 }
  },
  emits: {
    "update:model-value": (s) => !0,
    change: (s) => !0
  },
  setup(s, { emit: l }) {
    const a = s, t = l;
    return ce(re, {
      change(e, c) {
        if (a.selectMode == "single")
          c && (t("update:model-value", e), t("change", e));
        else if (c) {
          if (!a.modelValue || a.modelValue.indexOf(e) == -1) {
            let g = a.modelValue ? a.modelValue.slice() : [];
            g.push(e), t("update:model-value", g), t("change", g);
          }
        } else {
          let g = a.modelValue ? a.modelValue.filter((w) => w != e) : [];
          t("update:model-value", g), t("change", g);
        }
      },
      get selectMode() {
        return a.selectMode;
      },
      get value() {
        return a.selectMode == "single" || a.modelValue ? a.modelValue : [];
      }
    }), (e, c) => (C(), I("div", {
      class: M(["c-group-" + e.orientation])
    }, [
      j(e.$slots, "default")
    ], 2));
  }
}), Be = ["placeholder", "disabled", "rows", "value"], Ke = /* @__PURE__ */ A({
  __name: "CTextArea",
  props: {
    placeholder: { default: void 0 },
    disabled: { type: Boolean, default: !1 },
    minRows: { default: 1 },
    maxRows: {},
    modelValue: { default: "" }
  },
  emits: {
    "update:model-value": (s) => !0,
    change: (s) => !0
  },
  setup(s, { emit: l }) {
    const a = s;
    let t = te(() => {
      let g = 0;
      for (let S of a.modelValue)
        S == `
` && g++;
      let w = Math.max(g, a.minRows);
      return a.maxRows && w > a.maxRows && (w = a.maxRows), w;
    });
    const e = l;
    function c(g) {
      const w = g.target?.value || "";
      e("update:model-value", w), e("change", w);
    }
    return (g, w) => (C(), I("textarea", {
      placeholder: g.placeholder,
      autocomplete: "off",
      disabled: g.disabled,
      rows: V(t),
      class: M([
        "c-text-area" + (g.disabled ? "-disabled" : "")
      ]),
      value: g.modelValue,
      onInput: c
    }, null, 42, Be));
  }
}), Ee = ["placeholder", "value", "disabled"], Me = /* @__PURE__ */ A({
  __name: "CTextInput",
  props: {
    placeholder: { default: void 0 },
    disabled: { type: Boolean, default: !1 },
    modelValue: { default: "" }
  },
  emits: {
    "update:model-value": (s) => !0,
    change: (s) => !0
  },
  setup(s, { emit: l }) {
    const a = l;
    function t(e) {
      const c = e.target?.value || "";
      a("update:model-value", c), a("change", c);
    }
    return (e, c) => (C(), I("input", {
      type: "text",
      placeholder: e.placeholder,
      autocomplete: "off",
      value: e.modelValue,
      disabled: e.disabled,
      class: M([
        "c-text-input" + (e.disabled ? "-disabled" : "")
      ]),
      onInput: t
    }, null, 42, Ee));
  }
});
class X {
  static bindKeyId = 0;
  /**
   * 唯一ID 方便vue渲染节点
   */
  bindKey = X.bindKeyId++;
  /**
   * 父节点
   */
  parent;
  /**
   * 子节点
   */
  children;
  /**
   * 允许拥有子节点
   */
  haveChildren;
  /**
   * 是否是已折叠的
   */
  isFolded = !0;
  /**
   * 所绑定的数据
   */
  data;
  /**
   * 获取下一项,无论节点是否打开
   */
  get next() {
    if (this.children && this.children.length > 0)
      return this.children[0];
    {
      let l, a = this;
      for (; l == null && a != null && a.parent != null; )
        l = a.parent.children[a.parent.children.indexOf(a) + 1], a = a.parent;
      return l;
    }
  }
  /**
   * 获取上一项,无论节点是否打开
   */
  get prev() {
    if (this.parent) {
      let l = this.parent.children[this.parent.children.indexOf(this) - 1];
      if (l) {
        for (; l.children; )
          l = l.children[l.children.length - 1];
        return l;
      } else
        return this.parent;
    }
  }
  /**
   * 获取下一项,节点必须打开才会进入子节点
   */
  get nextOpend() {
    if (!this.isFolded && this.children && this.children.length > 0)
      return this.children[0];
    {
      let l, a = this;
      for (; l == null && a != null && a.parent != null; )
        l = a.parent.children[a.parent.children.indexOf(a) + 1], a = a.parent;
      return l;
    }
  }
  /**
   * 获取上一项,节点必须打开才会进入子节点
   */
  get prevOpend() {
    if (this.parent) {
      let l = this.parent.children[this.parent.children.indexOf(this) - 1];
      if (l) {
        for (; !l.isFolded && l.children; )
          l = l.children[l.children.length - 1];
        return l;
      } else
        return this.parent;
    }
  }
  /**
   * 查找自己的索引全局索引
   */
  get index() {
    let l = this.prev, a = 0;
    for (; l != null; )
      a++, l = l.prev;
    return a;
  }
  /**
   * 向上打开所有节点
   */
  openToParent() {
    let l = this.parent;
    for (; l; )
      l.isFolded = !1, l = l.parent;
  }
  /**
   * 遍历节点，进行逻辑上的关闭操作 返回true则折叠，false则打开
   * @param logic 
   */
  fold(l) {
    if (this.isFolded = l(this.data), this.children)
      for (let a of this.children)
        a.fold(l);
  }
  /**
   * 将树打开到目标数据
   * @param data 
   */
  openTo(l) {
    let a = this.find(l);
    if (a) {
      let t = a;
      for (; t != null; )
        t.isFolded = !1, t = t.parent;
    }
    return a;
  }
  /**
   * 查找数据对应的树对象
   * @param data 
   */
  find(l) {
    if (this.data == l)
      return this;
    if (this.children) {
      for (let a of this.children) {
        let t = a.find(l);
        if (t)
          return t;
      }
      return;
    } else
      return;
  }
  /**
   * 获取共有几个父节点
   */
  get parentCount() {
    let l = this.parent, a = 0;
    for (; l; )
      a++, l = l.parent;
    return a;
  }
  /**
   * 将原始数据转换成数据源数据，方便tree组件解析
   */
  static toDataSource(l, a) {
    let t = new X();
    if (t.data = l, l[a]) {
      t.children = [], t.haveChildren = !0;
      for (let e of l[a]) {
        let c = this.toDataSource(e, a);
        c.parent = t, t.children.push(c);
      }
    }
    return t;
  }
}
const $e = ["draggable"], Fe = {
  key: 0,
  class: "tree-item-icon fa fa-file-o"
}, Le = { key: 0 }, de = /* @__PURE__ */ A({
  __name: "CTreeNode",
  props: {
    dataSource: {},
    modelValue: {},
    multiChoice: { type: Boolean, default: !1 },
    gap: { default: 0 },
    currentSelected: {},
    itemDraggable: { type: Boolean },
    widgetId: {}
  },
  emits: {
    change: (s) => !0,
    changeSel: (s) => !0,
    dragstart: (s, l, a) => !0,
    dragover: (s, l, a) => !0,
    dragleave: (s, l, a) => !0,
    drop: (s, l, a) => !0,
    dragend: (s, l, a) => !0,
    doubleClickItem: (s, l) => !0
  },
  setup(s, { expose: l, emit: a }) {
    const t = O([]), e = s, c = a;
    function g(o) {
      if (e.multiChoice) {
        let D = e.modelValue, p = null;
        if (o.shiftKey)
          if (e.currentSelected == null)
            p = [e.dataSource], c("changeSel", e.dataSource);
          else {
            p = [];
            let T = e.currentSelected, d = e.dataSource;
            for (T.index > d.index && (T = e.dataSource, d = e.currentSelected), p.push(T); T != null && T.next != d; )
              T = T.next, T && p.push(T);
            p.push(d);
          }
        else
          o.ctrlKey ? (p = D.concat(), D.indexOf(e.dataSource) == -1 ? (p.push(e.dataSource), c("changeSel", e.dataSource)) : (p.splice(p.indexOf(e.dataSource), 1), c("changeSel", null))) : (p = [e.dataSource], c("changeSel", e.dataSource));
        p != null && c("change", p);
      } else
        e.dataSource != e.modelValue && c("change", e.dataSource);
    }
    function w(o, D, p) {
      c(
        "dragstart",
        o,
        D || e.dataSource,
        p ?? (e.dataSource.parent ? e.dataSource.parent.children.indexOf(e.dataSource) : null)
      );
    }
    function S(o, D, p) {
      c(
        "dragover",
        o,
        D || e.dataSource,
        p ?? (e.dataSource.parent ? e.dataSource.parent.children.indexOf(e.dataSource) : null)
      );
    }
    function k(o, D, p) {
      c(
        "dragleave",
        o,
        D || e.dataSource,
        p ?? (e.dataSource.parent ? e.dataSource.parent.children.indexOf(e.dataSource) : null)
      );
    }
    function B(o, D, p) {
      c(
        "drop",
        o,
        D || e.dataSource,
        p ?? (e.dataSource.parent ? e.dataSource.parent.children.indexOf(e.dataSource) : null)
      );
    }
    function P(o, D, p) {
      c(
        "dragend",
        o,
        D || e.dataSource,
        p ?? (e.dataSource.parent ? e.dataSource.parent.children.indexOf(e.dataSource) : null)
      );
    }
    function L(o) {
      c("doubleClickItem", o, e.dataSource), o.defaultPrevented || (e.dataSource.isFolded = !e.dataSource.isFolded);
    }
    function x(o) {
      c("change", o);
    }
    function z(o) {
      c("changeSel", o);
    }
    function G(o, D) {
      c("doubleClickItem", o, e.dataSource);
    }
    return l({ childRefs: t }), (o, D) => (C(), I("div", null, [
      N("div", {
        class: M(["c-tree-item", { "c-tree-item-sel": o.multiChoice ? o.modelValue.indexOf(o.dataSource) != -1 : o.modelValue == o.dataSource }]),
        draggable: o.itemDraggable,
        onClick: D[1] || (D[1] = W((p) => g(p), ["left"])),
        onDblclick: D[2] || (D[2] = W((p) => L(p), ["left"])),
        onDragstart: D[3] || (D[3] = (p) => w(p)),
        onDragover: D[4] || (D[4] = (p) => S(p)),
        onDragleave: D[5] || (D[5] = (p) => k(p)),
        onDrop: D[6] || (D[6] = (p) => B(p)),
        onDragend: D[7] || (D[7] = (p) => P(p))
      }, [
        (C(!0), I(q, null, Q(o.gap, (p) => (C(), I("div", {
          key: p,
          class: "c-tree-gap gap-line"
        }))), 128)),
        o.dataSource.children != null && o.dataSource.children.length > 0 ? (C(), I("i", {
          key: 0,
          class: M(["tree-fold-icon fa", { "fa-chevron-down": !o.dataSource.isFolded, "fa-chevron-right": o.dataSource.isFolded }]),
          "aria-hidden": "true",
          onClick: D[0] || (D[0] = (p) => o.dataSource.isFolded = !o.dataSource.isFolded)
        }, null, 2)) : Y("", !0),
        N("div", {
          class: M(["c-tree-item-content", ["tree-node-id-" + o.dataSource.bindKey]])
        }, [
          j(o.$slots, "icon", { tree: o.dataSource }, () => [
            o.dataSource.children == null ? (C(), I("i", Fe)) : Y("", !0)
          ]),
          j(o.$slots, "item", { tree: o.dataSource }, () => [
            Z(U(o.dataSource.bindKey), 1)
          ])
        ], 2)
      ], 42, $e),
      o.dataSource.children != null && o.dataSource.children.length > 0 && !o.dataSource.isFolded ? (C(), I("div", Le, [
        (C(!0), I(q, null, Q(o.dataSource.children, (p) => (C(), pe(de, {
          ref_for: !0,
          ref_key: "childRefs",
          ref: t,
          key: p.bindKey,
          dataSource: p,
          multiChoice: o.multiChoice,
          gap: o.gap + 1,
          modelValue: o.modelValue,
          currentSelected: o.currentSelected,
          widgetId: o.widgetId,
          itemDraggable: o.itemDraggable,
          onChange: x,
          onChangeSel: z,
          onDoubleClickItem: G,
          onDragstart: w,
          onDragover: S,
          onDragleave: k,
          onDrop: B,
          onDragend: P
        }, {
          item: ne((T) => [
            j(o.$slots, "item", {
              tree: T.tree
            }, () => [
              Z(U(T.tree.bindKey), 1)
            ])
          ]),
          _: 2
        }, 1032, ["dataSource", "multiChoice", "gap", "modelValue", "currentSelected", "widgetId", "itemDraggable"]))), 128))
      ])) : Y("", !0)
    ]));
  }
}), Re = {
  key: 0,
  class: "c-list-input"
}, Pe = /* @__PURE__ */ A({
  __name: "CTree",
  props: {
    dataSource: {},
    modelValue: {},
    multiChoice: { type: Boolean, default: !1 },
    itemDraggable: { type: Boolean, default: !1 },
    hideBorder: { type: Boolean, default: !1 }
  },
  emits: {
    "update:model-value": (s) => !0,
    change: (s) => !0,
    changeSel: (s) => !0,
    itemdragstart: (s, l) => !0,
    itemdropallow: (s, l, a) => !0,
    itemdrop: (s, l, a) => !0,
    drop: (s, l, a) => !0,
    dragend: (s, l, a) => !0,
    doubleClickItem: (s, l) => !0
  },
  setup(s, { expose: l, emit: a }) {
    const t = O(null), e = s;
    let c = O(!1), g = O(0), w = O(0), S = O(3), k = O(null), B = O(!1), P = O($.instance.widgetId);
    const L = O(null), x = a;
    function z(n) {
      x("update:model-value", n), x("change", n);
    }
    function G(n) {
      k.value = n;
    }
    function o(n, u) {
      x("doubleClickItem", n, e.dataSource);
    }
    function D(n, u) {
      if (n.dataSource == u)
        return n.$el;
      for (let b of n.childRefs) {
        let y = D(b, u);
        if (y)
          return y;
      }
    }
    async function p(n) {
      let u = n;
      for (; u != null; )
        u.isFolded = !1, u = u.parent;
      await _();
      let b = t.value?.childRefs[0], y = D(b, n);
      y && (L.value.scrollTop = y.offsetTop);
    }
    function T(n, u, b) {
      let y = new oe();
      y.widgetType = "c-tree", y.widgetId = P.value;
      let h;
      if (e.multiChoice ? e.modelValue == null || e.modelValue.indexOf(u) == -1 ? (h = [u], x("update:model-value", h), x("change", h)) : h = e.modelValue : e.modelValue != u ? (h = u, x("update:model-value", h), x("change", h)) : h = e.modelValue, e.multiChoice)
        for (let K of h)
          y.list.push({
            data: K,
            index: K.parent ? K.parent.children.indexOf(K) : -1,
            parent: K.parent
          });
      else
        y.list.push({
          data: h,
          index: b,
          parent: h.parent
        });
      x("itemdragstart", n, y), !n.defaultPrevented && n.dataTransfer && (n.dataTransfer.dropEffect = "move", n.dataTransfer.setData(
        "application/json",
        JSON.stringify(y, (K, R) => K == "parent" && R instanceof X ? null : R)
      ), n.dataTransfer.setDragImage(n.target, 0, 0), $.instance.currentDragData = y);
    }
    function d(n, u, b) {
      let y = i(n, u, b), h = new H();
      h.widgetType = "c-tree", h.widgetId = P.value, h.index = y.index, h.parent = e.dataSource, x(
        "itemdropallow",
        n,
        h,
        $.instance.currentDragData
      ), n.defaultPrevented && (g.value = y.top, c.value = !0, S.value = y.height, w.value = y.gap);
    }
    function f(n, u) {
      c.value = !1;
    }
    function m(n, u, b) {
      c.value = !1;
      let y = i(n, u, b), h = new H();
      h.widgetType = "c-tree", h.widgetId = P.value, h.index = y.index, h.parent = y.target;
      let K = $.instance.currentDragData;
      if (K)
        for (let R = 0; R < K.list.length; R++)
          K.list[R].data == h.parent && (K.list.splice(R, 1), R--);
      x("itemdrop", n, h, K);
    }
    function r() {
      $.instance.currentDragData = void 0;
    }
    function i(n, u, b) {
      let h = n.currentTarget.getBoundingClientRect(), K = L.value.getBoundingClientRect(), R = h.top - K.top + L.value.scrollTop;
      return (u.haveChildren ? n.clientY > h.top + h.height / 4 * 3 : n.clientY >= h.top + h.height / 2) ? {
        index: !u.isFolded && u.haveChildren ? 0 : b + 1,
        //已经关闭说明是向下插入
        target: !u.isFolded && u.haveChildren ? u : u.parent ? u.parent : void 0,
        //如果自己没用parent则不操作
        top: R + h.height,
        height: 3,
        isPutIn: !1,
        gap: ((!u.isFolded && u.haveChildren ? 1 : 0) + u.parentCount) * 11
        //已经打开则只能插入在子集
      } : (u.haveChildren ? n.clientY < h.top + h.height / 4 : n.clientY < h.top + h.height / 2) ? {
        index: u.parent ? b : 0,
        target: u.parent ? u.parent : u,
        top: R,
        height: 3,
        isPutIn: !1,
        gap: u.parentCount * 11
      } : {
        index: u.children ? u.children.length : 0,
        target: u,
        top: R,
        height: h.height,
        isPutIn: !0,
        gap: 0
      };
    }
    let v = "";
    async function E(n) {
      let u = L.value;
      if (n.code == "ArrowUp" || n.code == "ArrowDown") {
        if (e.modelValue == null) {
          const b = e.multiChoice ? [e.dataSource] : e.dataSource;
          x("update:model-value", b), x("change", b), u.scrollTop = 0;
        } else {
          let b;
          e.multiChoice ? b = e.modelValue[0] : b = e.modelValue;
          let y = n.code == "ArrowUp" ? b.prevOpend : b.nextOpend;
          if (y) {
            const K = e.multiChoice ? [y] : y;
            x("update:model-value", K), x("change", K), y.openToParent();
          }
          await _();
          let h = u.querySelector(".c-tree-item-sel");
          h && h.scrollIntoView({
            block: "nearest"
            // behavior: "smooth"//不要动画效果更好
          });
        }
        n.preventDefault();
      } else if (n.code == "ArrowLeft" || n.code == "ArrowRight") {
        let b;
        e.multiChoice ? b = e.modelValue[0] : b = e.modelValue, b && (b.isFolded = n.code == "ArrowLeft"), n.preventDefault();
      } else if (n.code >= "KeyA" && n.code <= "KeyZ" || n.code >= "Digit0" && n.code <= "Digit9" || n.code >= "Numpad0" && n.code <= "Numpad9") {
        let b = n.code.replace(/Key|Digit|Numpad/g, "");
        console.log(b), v += b, F();
      } else
        n.code == "Enter" && v != "" ? F() : n.code == "Backspace" && v != "" ? (v = v.substr(0, v.length - 1), v != "" && F()) : n.code == "Escape" && (v = "");
    }
    async function F() {
      let n;
      e.multiChoice ? e.modelValue == null || e.modelValue.length == 0 ? n = e.dataSource : n = e.modelValue[0] : e.modelValue == null ? n = e.dataSource : n = e.modelValue, n.openToParent(), await _(), n.haveChildren && n.isFolded && (n.isFolded = !1, await _());
      let u = n.next;
      for (; u != n; ) {
        u == null && (u = e.dataSource);
        let b = ge()?.proxy?.$el.querySelector(".tree-node-id-" + u.bindKey);
        if ((b.textContent || "").replace(/(?![A-Z|a-z|0-9])/g, "").toUpperCase().indexOf(v) != -1) {
          const h = e.multiChoice ? [u] : u;
          x("update:model-value", h), x("change", h), b.scrollIntoView({ block: "nearest" });
          break;
        }
        u.haveChildren && u.isFolded && (u.isFolded = !1, await _()), u = u.next;
      }
    }
    return l({ scrollTo: p }), (n, u) => (C(), I("div", {
      class: M(["c-list-out-box", { "c-tree-show-line": V(B), "c-list-no-border": n.hideBorder }]),
      onMouseover: u[0] || (u[0] = (b) => ee(B) ? B.value = !0 : B = !0),
      onMouseleave: u[1] || (u[1] = (b) => ee(B) ? B.value = !1 : B = !1),
      tabindex: "0",
      onKeydown: E
    }, [
      N("div", {
        class: M(["c-list-in-box", { "c-list-no-border": n.hideBorder }]),
        ref_key: "inbox",
        ref: L
      }, [
        fe(de, {
          ref_key: "treeRef",
          ref: t,
          dataSource: n.dataSource,
          multiChoice: n.multiChoice,
          modelValue: n.modelValue,
          currentSelected: V(k),
          widgetId: V(P),
          itemDraggable: n.itemDraggable,
          onChange: z,
          onChangeSel: G,
          onDoubleClickItem: o,
          onDragstart: T,
          onDragover: d,
          onDragleave: f,
          onDrop: m,
          onDragend: r,
          class: "c-tree-node"
        }, {
          item: ne(({ tree: b }) => [
            j(n.$slots, "item", { tree: b }, () => [
              Z(U(b.bindKey), 1)
            ])
          ]),
          _: 3
        }, 8, ["dataSource", "multiChoice", "modelValue", "currentSelected", "widgetId", "itemDraggable"]),
        V(c) ? (C(), I("div", {
          key: 0,
          class: "c-tree-drop-view",
          style: ae({ top: V(g) + "px", "--gap-width": V(w), height: V(S) + "px" })
        }, null, 4)) : Y("", !0)
      ], 2),
      V(v) != "" ? (C(), I("label", Re, U(V(v)), 1)) : Y("", !0)
    ], 34));
  }
}), le = { CButton: ve, CCheckBox: Se, CGroup: we, CList: Ve, CNumberInput: Te, CSelectableGroup: Oe, CTextArea: Ke, CTextInput: Me, CTree: Pe }, Ae = (s) => {
  for (let l in le)
    s.component(l, le[l]);
};
export {
  ve as CButton,
  Se as CCheckBox,
  we as CGroup,
  Ve as CList,
  Te as CNumberInput,
  Oe as CSelectableGroup,
  Ke as CTextArea,
  Me as CTextInput,
  Pe as CTree,
  X as TreeNodeData,
  Ae as install
};
//# sourceMappingURL=compactui2.es.js.map
